/*
 * Copyright 
 *   2010 axYus - www.axyus.com
 *   2010 Christel ESCOBAR - christel.escobar@axyus.com
 * 
 * This file is part of XEMELIOS.
 * 
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.cp.xemelios.controls.pesv2.comm;

import java.util.Hashtable;
import java.util.Vector;

import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;

import fr.gouv.finances.cp.xemelios.controls.AbstractUnitControl;
import fr.gouv.finances.cp.xemelios.controls.Anomalie;
import fr.gouv.finances.cp.xemelios.controls.IdGenerator;
import fr.gouv.finances.cp.xemelios.controls.Node;
import fr.gouv.finances.cp.xemelios.controls.pesv2.ConstantsControlsPESv2;

/**
 * Implémente le contrôle N° COMM06B - Contrôle relatif au Finess Juridique - Contrôle du fichier
 * Il consiste à vérifier la règle fonctionnelle suivante :
 * 		2) Si PAR1 = M21, vérifier que la balise EnTetePes/FinJur est présente dans le fichier
 * 		Dans le cas contraire générer une anomalie : « pour une M21 le finess juridique doit être présent dans le flux et correspondre au paramétrage »
 * 		3) Si PAR1 <> M21, vérifier que la balise EnTetePes/FinJur n’est pas présente dans le fichier
 * 		Dans le cas contraire générer une anomalie : « Le finess juridique ne doit être présent que pour les M21 »

 */
public class COMM06B extends AbstractUnitControl implements ConstantsControlsPESv2 {
	private final static Logger logger = Logger.getLogger(COMM06B.class);
    public static final transient String CTRL_ID = "COMM06B";
	private Vector<Anomalie> anos = new Vector<Anomalie>();
	private Hashtable<String,Object> hParams;
	
	private String docId = null;
	
	/**
	 * La chaine cible
	 */
	private static final String CHEMIN_FIN = "PES_Aller/";
	private static final String ON_RETURN_ANOMALIES = CHEMIN_FIN;
	
	/**
	 * Variables contenant les valeurs nécessaires à ce contrôle
	 */
	private String PAR1 = "";
	private String PAR2 = "";

	private String bord_Exer = "";
	private String bord_IdBord = "";
	private String bord_TypBord = "";
	
	private String finjur = "";
	private String finjur_NodeId = "";
	private boolean finjur_present = false;
	
	private boolean first_bordereau = false;
	
	/**
	 * Variables devant être remplacées dans le message
	 */
	private static final String MSG_FINJUR = "#FINJUR#";
	private static final String MSG_FINJUR_PARAM = "#FINJUR_PARAM#";
	private static final String MSG_ERREUR = "#ERREUR#";
	
	/**
	 * Chemins incomplet vers les divers éléments que l'on veux lire. Ils sont incomplets dans la mesure 
	 * où on n'a pas le début du chemin, vu que ce contrôle est utilisé pour les Dépenses et les Recettes
	 */
	private static final String RECETTE = "PES_RecetteAller";
	private static final String DEPENSE = "PES_DepenseAller";
	private boolean depense = false;
	
	private static final String CHEMIN_BLOCBORDEREAU = "/Bordereau/BlocBordereau/";
	private static final String CHEMIN_BLOCBORDEREAU_EXER = "/Bordereau/BlocBordereau/Exer/";
	private static final String CHEMIN_BLOCBORDEREAU_IDBORD = "/Bordereau/BlocBordereau/IdBord/";
	private static final String CHEMIN_BLOCBORDEREAU_TYPBORD = "/Bordereau/BlocBordereau/TypBord/";
	
	private static final String CHEMIN_FINJUR = "/EnTetePES/FinJur/";
	
	
	public void startDocument() throws SAXException {
		logger.info("In "+CTRL_ID);
	}
	
	public void setDocId(String docID) {
		this.docId = docID;		
	}

	public void startElement(String uri, String localName, String qName,Attributes atts, String xpath) {
		// RECETTE ou DEPENSE
		if (xpath.indexOf(DEPENSE)!=-1) {
			depense = true;
		}
		if (xpath.indexOf(RECETTE)!=-1) {
			depense = false;
		}
		if (xpath.endsWith(CHEMIN_FINJUR)) {
			finjur = atts.getValue("V");
			finjur_NodeId = atts.getValue("ano:node-id");
			finjur_present = true;
		}
		if (!first_bordereau){
			if (xpath.endsWith(CHEMIN_BLOCBORDEREAU)) {
				bord_Exer = bord_IdBord = bord_TypBord = "";			
			}
			if (xpath.endsWith(CHEMIN_BLOCBORDEREAU_EXER)) {
				bord_Exer = atts.getValue("V");
			}
			if (xpath.endsWith(CHEMIN_BLOCBORDEREAU_IDBORD)) {
				bord_IdBord = atts.getValue("V");
			}
			if (xpath.endsWith(CHEMIN_BLOCBORDEREAU_TYPBORD)) {
				bord_TypBord = atts.getValue("V");
				first_bordereau = true;		
			}
		}
	}
	

	public Vector<Anomalie> endElement(String uri, String localName, String qName, String xpath) throws SAXException {
		if(xpath.equals(CHEMIN_FIN)){
			PAR1 = (String)hParams.get("nomencl");
			if (hParams.get("finJur")!=null) 
				PAR2 = (String)hParams.get("finJur");
			boolean err = false;
			String erreur = "";
			
			if (PAR1.equals("M21") && (!finjur_present || !finjur.equals(PAR2))) {
				err = true;
				erreur = "Pour une M21, le finess juridique doit être présent dans le flux et correspondre au paramétrage.";
			}
			if (!PAR1.equals("M21") && finjur_present) {
				err = true;
				erreur = "Le finess juridique ne doit être présent que pour les M21.";
			}
			
			if (err) {
				String msg = getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
				msg = msg.replaceAll(MSG_ERREUR, erreur);
				msg = msg.replaceAll(MSG_FINJUR, finjur);
				msg = msg.replaceAll(MSG_FINJUR_PARAM, PAR2);

				String path="@added:primary-key='"+bord_Exer+"-"+bord_TypBord+"-"+bord_IdBord+"'";
				String anoId = IdGenerator.nextId();
				String libelleLien = "Bordereau "+bord_IdBord;
				Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
				xslParams.put("elementId", "Bordereau");
				xslParams.put("mandatId", "");
				xslParams.put("browser-destination", "internal");
				xslParams.put("anoId", anoId);
				Anomalie ano = new Anomalie(anoId,
                                        getDocumentModel().getControlById(CTRL_ID).getId(),
                                        getDocumentModel().getControlById(CTRL_ID).getLibelle(),
                                        getDocumentModel().getDocumentId(),
                                        (depense?DEPENSE:RECETTE),
                                        (depense?BORDEREAU_DEPENSE:BORDEREAU_RECETTE), // élément importable
                                        bord_IdBord, // id élément importable
                                        localName,
                                        libelleLien,
                                        msg,
                                        getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
                                        getDocumentModel().getControlById(CTRL_ID).getSeverity(),
                                        path,
                                        xslParams);
				ano.addNode(new Node(finjur_NodeId));
				anos.add(ano);
			}
				
			return anos;
		} else {
			return null;
		}
	}

	public void endDocument() throws SAXException {}
	
	public void characters(char[] ch, int start, int length, String xpath) {}
	
	public void ignorableWhitespace(char[] ch, int start, int length,String xpath) {}
	
	public void startPrefixMapping(String prefix, String uri, String xpath) {}
	
	public void endPrefixMapping(String prefix, String xpath) {}
	
	public void processingInstruction(String target, String data, String xpath) {}
	
	public void skippedEntity(String name, String xpath) {}
	
	public void setParameters(Hashtable<String,Object> params) {
		this.hParams=params;
	}
	
	public void setDocumentLocator(Locator locator) {}
}
